:- use_module(library(lists), [member/2, reverse/2]).

jrat('Budapest', 'Prga', 515).
jrat('Budapest', 'Bcs', 245).
jrat('Bcs', 'Berlin', 635).
jrat('Bcs', 'Prizs', 1265).


% tszakasz(A, B, H): A-bl B-be eljuthatunk egy H thossz jrattal.
tszakasz(Kezdet, Cl, Tv) :-
     (   jrat(Kezdet, Cl, Tv)
     ;   jrat(Cl, Kezdet, Tv)
     ).

% tvonal_3(N, A, B, t, H): A s B kztt van (pontosan)
% N szakaszbl ll krmentes  t tvonal, amelynek sszhossza H.
tvonal_3(N, Honnan, Hov, t, H) :-
        tvonal_3(N, Honnan, Hov,  [Honnan], Ft, H),
	reverse(Ft, t).

% tvonal_3(N, A, B, Ft0, Ft, H): A s B kztt van pontosan
% N szakaszbl ll krmentes, Ft0 elemein t nem men H hossz
% t, amelynek fordtottjt Ft0 el fzve kapjuk a Ft listt.
tvonal_3(0, Hov, Hov,  Ft, Ft, 0).
tvonal_3(N, Honnan, Hov, Ft0,  Ft, H) :-
        N > 0, N1 is N-1, 
        tszakasz(Honnan, Kzben, H1),
        \+ member(Kzben, Ft0),
        tvonal_3(N1, Kzben, Hov, [Kzben|Ft0],  Ft, H2), 
	H is H1+H2.
