:- use_module(library(lists), [select/3]).

% tvonal_4(N, G, A, B, L, H): A G grfban van egy  A-bl
% B-be men N szakaszbl ll L t, melynek sszhossza H.
tvonal_4(0, _Grf, Hov, Hov, [Hov], 0).
tvonal_4(N, Grf, Honnan, Hov, [Honnan|t], H) :-
        N >0, N1 is N-1,
        select(l, Grf, Grf1),
        l_vgpontok_hossz(l, Honnan, Kzben, H1),
        tvonal_4(N1, Grf1, Kzben, Hov, t, H2), H is H1+H2.

% l_vgpontok_hossz(l, A, B, H): Az l irnytatlan l 
% vgpontjai A s B, hossza H.
l_vgpontok_hossz(l(A,B,H), A, B, H).
l_vgpontok_hossz(l(A,B,H), B, A, H).

hlzat([l('Budapest','Bcs',245), l('Budapest','Prga',515),
	 l('Bcs','Berlin',635), l('Bcs','Prizs',1265)]).

end_of_file.

| ?- hlzat(_Grf), tvonal_4(2, _Grf, 'Budapest', _, t, H).
H = 880, t = ['Budapest','Bcs','Berlin'] ? ;
H = 1510, t = ['Budapest','Bcs','Prizs'] ? ; no
