% :- block plus(-, ?, -).	
plus(0, X, X).			% 0+X = X.
plus(s(X), Y, s(Z)) :-
	plus(X, Y, Z).          % s(X)+Y = s(X+Y).

peano_to_int(0, N, N).
peano_to_int(s(X), N0, N) :-
	N1 is N0+1,
	peano_to_int(X, N1, N).

int_to_peano(N, P) :-
	(   integer(N), N > 0
	->  N1 is N-1, P = s(P0),
	    int_to_peano(N1, P0)
	;   P = N
	).

	
