:- ensure_loaded(peano).

% :- type tree ---> leaf(int) | node(tree, tree).

sum_tree(leaf(Value), Value).
sum_tree(node(Left, Right), S) :-
	plus(S1, S2, S),
	S1 \= 0, S2 \= 0,
	sum_tree(Left, S1),
	sum_tree(Right, S2).


